#ifndef SBK_KDIRWATCHWRAPPER_H
#define SBK_KDIRWATCHWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <kdirwatch.h>

namespace Shiboken { class AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class KDirWatchWrapper : public KDirWatch
{
public:
    KDirWatchWrapper(::QObject * parent = nullptr);
    KDirWatchWrapper(const KDirWatchWrapper &) = delete;
    KDirWatchWrapper& operator=(const KDirWatchWrapper &) = delete;
    KDirWatchWrapper(KDirWatchWrapper &&) = delete;
    KDirWatchWrapper& operator=(KDirWatchWrapper &&) = delete;
    ~KDirWatchWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[7] = {false, false, false, false, false, false, false};
};

#endif // SBK_KDIRWATCHWRAPPER_H
