#ifndef SBK_KWORDMACROEXPANDERWRAPPER_H
#define SBK_KWORDMACROEXPANDERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <kmacroexpander.h>

namespace Shiboken { class AutoDecRef; class GilState; }

class KWordMacroExpanderWrapper : public KWordMacroExpander
{
public:
    KWordMacroExpanderWrapper(::QChar c = QLatin1Char('%'));
    KWordMacroExpanderWrapper(const KWordMacroExpanderWrapper &) = delete;
    KWordMacroExpanderWrapper& operator=(const KWordMacroExpanderWrapper &) = delete;
    KWordMacroExpanderWrapper(KWordMacroExpanderWrapper &&) = delete;
    KWordMacroExpanderWrapper& operator=(KWordMacroExpanderWrapper &&) = delete;
    ~KWordMacroExpanderWrapper() override;

    int expandEscapedMacro(const ::QString & str, int pos, ::QStringList & ret) override;
    bool expandMacro(const ::QString & str, ::QStringList & ret) override;
    static bool sbk_o_expandMacro(const char *ownerClassName, const char *funcName, Shiboken::GilState &gil, const Shiboken::AutoDecRef &pyOverride, const ::QString & str, ::QStringList & ret);
    int expandPlainMacro(const ::QString & str, int pos, ::QStringList & ret) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable bool m_PyMethodCache[3] = {false, false, false};
};

#endif // SBK_KWORDMACROEXPANDERWRAPPER_H
